package net.ihe.gazelle.simulator.svs.repository;

import net.ihe.gazelle.common.interfacegenerator.GenerateInterface;
import net.ihe.gazelle.svs.RetrieveMultipleValueSetsRequestType;
import net.ihe.gazelle.svs.RetrieveMultipleValueSetsResponseType;
import net.ihe.gazelle.svs.RetrieveValueSetRequestType;
import net.ihe.gazelle.svs.RetrieveValueSetResponseType;
import org.jboss.seam.Component;
import org.jboss.seam.annotations.Name;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jws.*;
import javax.jws.soap.SOAPBinding;
import javax.persistence.EntityManager;
import javax.servlet.http.HttpServletRequest;
import javax.xml.namespace.QName;
import javax.xml.soap.*;
import javax.xml.ws.*;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import javax.xml.ws.soap.Addressing;
import javax.xml.ws.soap.SOAPFaultException;
import java.util.Iterator;
import java.util.Locale;

/**
 * This class was generated by the JAX-WS RI. JAX-WS RI 2.1.3-b02- Generated source version: 2.0
 * 
 */
@Stateless
@Name("soapRepository")
@WebService(portName = "ValueSetRepository_Port_Soap12", name = "ValueSetRepository_PortType", targetNamespace = "urn:ihe:iti:svs:2008", serviceName = "ValueSetRepository_Service")
@SOAPBinding(parameterStyle = SOAPBinding.ParameterStyle.BARE)
// Unwrap parameters
@Addressing(enabled = true, required = true)
// Adds header in response and allows server to process mustUnderstand
// Generate remote interface using Maven plugin
@BindingType(javax.xml.ws.soap.SOAPBinding.SOAP12HTTP_BINDING)
// Force SOAP 1.2
@RespectBinding(enabled = true)
@GenerateInterface(value = "SoapRepositoryRemote", isLocal = false, isRemote = true)
@HandlerChain(file = "soap-handler.xml")
public class SoapRepository implements SoapRepositoryRemote {

	private static final String SVS_NS = "urn:ihe:iti:svs:2008";
	private static Logger log = LoggerFactory.getLogger(SoapRepository.class);
	// SOAP Context
	@Resource
	WebServiceContext context;

	/**
	 * Method Repository SOAP ITI-60
	 * @param request RetrieveValueSetRequestType
	 * @return RetrieveValueSetResponseType
	 * @throws NAVFault nav
	 * @throws VERUNKFault verunk
	 * @throws SOAPException soap
	 */
	@WebMethod(operationName = "ValueSetRepository_RetrieveValueSet", action = "urn:ihe:iti:svs:2008:RetrieveValueSet")
	@WebResult(name = "RetrieveValueSetResponse", partName = "body", targetNamespace = SVS_NS)
	@Action(input = "urn:ihe:iti:2008:RetrieveValueSet", output = "urn:ihe:iti:2008:RetrieveValueSetResponse", fault = {
			@FaultAction(className = NAVFault.class, value = "NAV"),
			@FaultAction(className = VERUNKFault.class, value = "VERUNK") })
	public RetrieveValueSetResponseType valueSetRepositoryRetrieveValueSet(
			@WebParam(name = "RetrieveValueSetRequest", partName = "body", targetNamespace = SVS_NS) RetrieveValueSetRequestType request)
			throws NAVFault, VERUNKFault, SOAPException {

		// Get The Ip Adress of the Issuer
		MessageContext msgCtxt = context.getMessageContext();
		HttpServletRequest req = (HttpServletRequest) msgCtxt.get(MessageContext.SERVLET_REQUEST);
		String ipAddress = req.getRemoteAddr();

		// display request content
		if (request != null) {
			RepositoryCore core = new RepositoryCore();
			RetrieveValueSetResponseType response = core.buildResponseToRetrieveValueSet(request);
			if (response == null) {
				core.saveReceivedTransactionInstance(request, null, "ITI-48", ipAddress, "SOAP",
						(EntityManager) Component.getInstance("entityManager"));
				String status = core.getResponseStatus();
				if (status.equals(RepositoryCore.NAV)) {
					SOAPFault fault = SOAPFactory.newInstance(SOAPConstants.SOAP_1_2_PROTOCOL)
							.createFault();
					fault.setFaultString("Unknown value set", Locale.ENGLISH);
					throw new NAVFault(fault);
				} else if (status.equals(RepositoryCore.VERUNK)) {
					SOAPFault fault = SOAPFactory.newInstance(SOAPConstants.SOAP_1_2_PROTOCOL)
							.createFault();
					fault.setFaultString("Version unknown", Locale.ENGLISH);
					throw new VERUNKFault(fault);
				} else {
					throw new SOAPException("An unexpected error occurred");
				}
			} else {
				core.saveReceivedTransactionInstance(request, response, "ITI-48", ipAddress, "SOAP",
						(EntityManager) Component.getInstance("entityManager"));
				return response;
			}
		} else {
			throw new SOAPException("The received request is null or empty");
		}
	}

	/**
	 * Method Repository SOAP ITI-60
	 *
	 * @param request RetrieveMultipleValueSetsRequestType
	 * @return RetrieveMultipleValueSetsResponseType
	 */
	@WebMethod(operationName = "ValueSetRepository_RetrieveMultipleValueSets", action = "urn:ihe:iti:svs:2010:RetrieveMultipleValueSets")
	@WebResult(name = "RetrieveMultipleValueSetsResponse", partName = "body", targetNamespace = SVS_NS)
	@Action(input = "urn:ihe:iti:2010:RetrieveMultipleValueSets", output = "urn:ihe:iti:2010:RetrieveMultipleValueSetsResponse")
	public RetrieveMultipleValueSetsResponseType valueSetRepositoryRetrieveMultipleValueSets(
			@WebParam(name = "RetrieveMultipleValueSetsRequest", partName = "body", targetNamespace = SVS_NS) RetrieveMultipleValueSetsRequestType request) {

		// Get The Ip Adress of the Issuer
		MessageContext msgCtxt = context.getMessageContext();
		HttpServletRequest req = (HttpServletRequest) msgCtxt.get(MessageContext.SERVLET_REQUEST);
		String ipAddress = req.getRemoteAddr();
		RepositoryCore core = new RepositoryCore();
		RetrieveMultipleValueSetsResponseType response = core.buildResponseToRetrieveMultipleValueSets(request);
		core.saveReceivedTransactionInstance(request, response, "ITI-60", ipAddress, "SOAP",
				(EntityManager) Component.getInstance("entityManager"));
		return response;
	}

	/**
	 * Keeps this method there (aberge)
	 */
	@SuppressWarnings("unused")
	private void readSoapHeader() {
		// extract the SOAP header and all its elements
		SOAPMessageContext jaxwsContext = (SOAPMessageContext) context.getMessageContext();
		try {
			SOAPHeader soapHeader = jaxwsContext.getMessage().getSOAPPart().getEnvelope().getHeader();
			Iterator<?> iterator = soapHeader.getChildElements();
			if (iterator != null) {
				while (iterator.hasNext()) {
					Object element = iterator.next();
					if (element instanceof SOAPElement) {
						log.info("soap element: " + ((SOAPElement) element).getElementName().getLocalName());
					}
				}
			}
		} catch (SOAPException e) {
			log.error(e.getMessage(), e);
		}
	}

	/**
	 * SOAP fault returned when the requested id does not match a value set known by the repository
	 *
	 * @author aberge
	 *
	 */
	@WebFault(name = "NAV", targetNamespace = "urn:ihe:iti:svs:2008")
	public class NAVFault extends SOAPFaultException {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		public NAVFault(SOAPFault fault) {
			super(fault);
			try {
				getFault().setFaultCode(new QName("http://www.w3.org/2003/05/soap-envelope", "Sender"));
				getFault().appendFaultSubcode(new QName(SVS_NS, "NAV"));
				getFault().addFaultReasonText("Unknown value set", Locale.ENGLISH);
			} catch (SOAPException e) {
				log.error("Unable to build NAV SOAPFault");
				e.getMessage();
			}
		}
	}

	/**
	 * SOAP fault returned when the requested version does not exist for the requested value set
	 *
	 * @author aberge
	 *
	 */
	@WebFault(name = "VERUNK", targetNamespace = "urn:ihe:iti:svs:2008")
	public class VERUNKFault extends SOAPFaultException {

		/**
		 *
		 */
		private static final long serialVersionUID = 1L;

		public VERUNKFault(SOAPFault fault) {
			super(fault);
			try {
				getFault().setFaultCode(new QName("http://www.w3.org/2003/05/soap-envelope", "Sender"));
				getFault().appendFaultSubcode(new QName(SVS_NS, "VERUNK"));
				getFault().addFaultReasonText("Version unknown", Locale.ENGLISH);
			} catch (SOAPException e) {
				e.getMessage();
			}
		}
	}

}
